*** swank.lisp	2009-02-28 22:28:29.920418495 +0300
--- swank-asdf.lisp	2009-03-01 13:03:14.551771267 +0300
***************
*** 3175,3182 ****
  DSPEC is a string and LOCATION a source location. NAME is a string."
    (multiple-value-bind (sexp error) (ignore-errors (values (from-string name)))
      (unless error
!       (mapcar #'xref>elisp (find-definitions sexp)))))
  
  (defslimefun xref (type name)
    (let ((symbol (parse-symbol-or-lose name *buffer-package*)))
      (mapcar #'xref>elisp
--- 3175,3206 ----
  DSPEC is a string and LOCATION a source location. NAME is a string."
    (multiple-value-bind (sexp error) (ignore-errors (values (from-string name)))
      (unless error
!       (mapcar #'xref>elisp (find-definitions-with-asdf sexp)))))
  
+ (defun find-definitions-with-asdf (name)
+   (append (find-definitions name)
+           #+asdf
+           (find-asd-definition name)))
+ 
+ #+asdf
+ (defun find-asd-definition (name)
+   (let ((sys (asdf:find-system name nil)))
+     (when sys
+       `(((ASDF:DEFSYSTEM ,name)
+          (:LOCATION
+           (:FILE
+            ,(find-asd-filename sys))
+           (:POSITION 1)
+           (:SNIPPET "")))))))
+ 
+ #+asdf
+ (defun find-asd-filename (system)
+   (namestring
+    (translate-logical-pathname
+     (merge-pathnames (slot-value system 'asdf::relative-pathname)
+                      (make-pathname :name (slot-value system 'asdf::name)
+                                     :type "asd")))))
+   
  (defslimefun xref (type name)
    (let ((symbol (parse-symbol-or-lose name *buffer-package*)))
      (mapcar #'xref>elisp
